TOOL_NAME = "Channel-Strip Buddy"

--Renoise Keybinds and menus
-------------------------------
renoise.tool():add_keybinding {
  name = "Global:Tools:`CSB` Toggle Target Device", 
  invoke = function()open_current_dev()end  
}

renoise.tool():add_keybinding {
  name = "Global:Tools:`CSB` Set Selected as Target Device", 
  invoke = function()set_target_device()end  
}

renoise.tool():add_menu_entry {
  name = "DSP Device:CSB - Set as Target",
  invoke = function()set_target_device()end  
}

renoise.tool():add_menu_entry {
  name = "Mixer:CSB - Set as Target",
  invoke = function()set_target_device()end  
}


--global variables
local g_selected_track_index = nil
--global target device
local g_target_device_path = nil
local g_current_dev = nil


------------------------------------------
--Set up Preferences file
------------------------------------------
--create xml
local options = renoise.Document.create {
  last_path = "",
}
 --assign options-object to .preferences so renoise knows to load and update it with the tool
renoise.tool().preferences = options
------------------------------------------
------------------------------------------
--variable syntax 
--options.value_a.value

--helper function : custom status message --prefixes tool name and adds brackets 
------------------------
function status(message)
------------------------
  renoise.app():show_status(TOOL_NAME.." Tool: ("..message..")")
end
----
----------------------------
function set_target_device()
----------------------------
  g_target_device_path = renoise.song().selected_track_device.device_path
  --set options value
  options.last_path.value = g_target_device_path
  --call status
  renoise.app():show_status("CSB  Target = "..renoise.song().selected_track_device.display_name)
end
----

---------------------------
--Open Current Dev function
----------------------------
function open_current_dev()
---------------------------

  --get path from options if exists
  if options.last_path.value ~= "" then
    g_target_device_path = options.last_path.value
  end
 
  if g_target_device_path == nil then
    status("Right Click On A Device To Set It As The Target")
    return
  end
  
  --vars
  local song = renoise.song()
  local track = song.selected_track
  local target_path = g_target_device_path
  local cur_track_instance_closed = false
  
  --loop all tracks to close any open instances
  ---------------------------------------------
  for track = 1,#song.tracks do
    for dev = 2, #song:track(track).devices do
      local cur_dev = song:track(track):device(dev)
      if cur_dev.device_path == target_path then
        if (cur_dev.external_editor_available == true) and
           (cur_dev.external_editor_visible == true) then
          --close editor  
          cur_dev.external_editor_visible = false
          --flag that the device was already open on the current track
          if track == song.selected_track_index then
            cur_track_instance_closed = true
          end
        end
      end
    end
  end
  
  --if flag true, then toggled gui on current track closed, so end here
  if cur_track_instance_closed == true then
    return
  end
  
  --loop devices in current track to search for target device.
  --open editor if it has one.
  ---------------------------------------------------------------------
  for dev = 2,#track.devices do
    local cur_dev = track:device(dev)
    if cur_dev.device_path == target_path then
      --select the device
      song.selected_track_device_index = dev
      --has editor?
      if (cur_dev.external_editor_available == true) and
         (cur_dev.external_editor_visible == false) then
        --open editor  
        cur_dev.external_editor_visible = true 
      end
      --device found so return
      return
    end
  end
  
  --if here, no device was found so add it and open ed.
  -----------------------------------------------------
  local new = track:insert_device_at(target_path, #track.devices + 1)
  --select device
  song.selected_device_index = #track.devices
  if (new.external_editor_available == true) and
     (new.external_editor_visible == false) then
    --open editor  
    new.external_editor_visible = true
  end
end





-------------------
-------------------








--[[
-------------------------------------------
function close_device_on_track_change()
------------------------------------------------  
  print("called")
  if g_current_dev.external_editor_visible == true then
    g_current_dev.external_editor_visible = false
  end
  renoise.song().selected_track_observable:remove_notifier(close_device_on_track_change)
end
---
--]]
--notifier
-----------
--[[
g_current_dev = cur_dev
if song.selected_track_observable:has_notifier(close_device_on_track_change) == false then
 song.selected_track_observable:add_notifier(close_device_on_track_change)
end
--]]







